Commit 94b22e05 authored by Josh Coalson's avatar Josh Coalson
Browse files

extend tests with --disable-...-subframe loops; precursor to valgrind support

parent e5259179
......@@ -22,6 +22,12 @@ export LD_LIBRARY_PATH
PATH=../src/flac:../obj/bin:$PATH
BINS_PATH=../../test_files/bins
flac --help 1>/dev/null 2>/dev/null || (echo "ERROR can't find flac executable" 1>&2 && exit 1)
if [ $? != 0 ] ; then exit 1 ; fi
#FLAC="valgrind --leak-check=yes --show-reachable=yes --logfile-fd=1 flac"
FLAC=flac
test -d ${BINS_PATH} || exit 77
test_file ()
......@@ -32,7 +38,7 @@ test_file ()
encode_options="$4"
echo -n "$name (--channels=$channels --bps=$bps $encode_options): encode..."
cmd="flac --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options $name.bin"
cmd="$FLAC --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options $name.bin"
echo "### ENCODE $name #######################################################" >> ./streams.log
echo "### cmd=$cmd" >> ./streams.log
if $cmd 2>>./streams.log ; then : ; else
......@@ -40,7 +46,7 @@ test_file ()
exit 1
fi
echo -n "decode..."
cmd="flac --silent --endian=big --sign=signed --decode --force-raw-format $name.flac";
cmd="$FLAC --silent --endian=big --sign=signed --decode --force-raw-format $name.flac";
echo "### DECODE $name #######################################################" >> ./streams.log
echo "### cmd=$cmd" >> ./streams.log
if $cmd 2>>./streams.log ; then : ; else
......@@ -59,19 +65,26 @@ test_file ()
}
echo "Testing bins..."
for f in b00 b01 b02 b03 ; do
for channels in 1 2 4 8 ; do
for bps in 8 16 24 ; do
for opt in 0 1 2 4 5 6 8 ; do
for extras in '' '-p' '-e' ; do
for blocksize in '' '--lax -b 32' '--lax -b 32768' '--lax -b 65535' ; do
test_file $BINS_PATH/$f $channels $bps "-$opt $extras $blocksize"
for f in b00 b01 b02 b03 b04 ; do
binfile=$BINS_PATH/$f
if [ -f $binfile ] ; then
for disable in '' '--disable-verbatim-subframes --disable-constant-subframes' '--disable-verbatim-subframes --disable-constant-subframes --disable-fixed-subframes' ; do
for channels in 1 2 4 8 ; do
for bps in 8 16 24 ; do
for opt in 0 1 2 4 5 6 8 ; do
for extras in '' '-p' '-e' ; do
for blocksize in '' '--lax -b 32' '--lax -b 32768' '--lax -b 65535' ; do
test_file $binfile $channels $bps "-$opt $extras $blocksize $disable"
done
done
done
if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
test_file $binfile $channels $bps "-b 16384 -m -r 8 -l 32 -e -p $disable"
fi
done
done
if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
test_file $BINS_PATH/$f $channels $bps "-b 16384 -m -r 8 -l 32 -e -p"
fi
done
done
else
echo "$binfile not found, skipping."
fi
done
......@@ -39,15 +39,18 @@ else
echo "flac --ogg doesn't work"
fi
#FLAC="valgrind --leak-check=yes --show-reachable=yes --logfile-fd=1 flac"
FLAC=flac
#
# multi-file tests
#
echo "Generating multiple input files from noise..."
if flac --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=16 --channels=2 noise.raw ; then : ; else
if $FLAC --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=16 --channels=2 noise.raw ; then : ; else
echo "ERROR generating FLAC file" 1>&2
exit 1
fi
if flac --decode --silent noise.flac ; then : ; else
if $FLAC --decode --silent noise.flac ; then : ; else
echo "ERROR generating WAVE file" 1>&2
exit 1
fi
......@@ -73,14 +76,14 @@ test_multifile ()
encode_options="$encode_options --sector-align"
fi
if flac $encode_options file0.wav file1.wav file2.wav ; then : ; else
if $FLAC $encode_options file0.wav file1.wav file2.wav ; then : ; else
echo "ERROR" 1>&2
exit 1
fi
for n in 0 1 2 ; do
mv file$n.$suffix file${n}x.$suffix
done
if flac --decode file0x.$suffix file1x.$suffix file2x.$suffix ; then : ; else
if $FLAC --decode file0x.$suffix file1x.$suffix file2x.$suffix ; then : ; else
echo "ERROR" 1>&2
exit 1
fi
......@@ -138,7 +141,7 @@ test_file ()
encode_options="$4"
echo -n "$name (--channels=$channels --bps=$bps $encode_options): encode..."
cmd="flac --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options $name.raw"
cmd="$FLAC --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options $name.raw"
echo "### ENCODE $name #######################################################" >> ./streams.log
echo "### cmd=$cmd" >> ./streams.log
if $cmd 2>>./streams.log ; then : ; else
......@@ -146,7 +149,7 @@ test_file ()
exit 1
fi
echo -n "decode..."
cmd="flac --silent --endian=big --sign=signed --decode --force-raw-format --output-name=$name.cmp $name.flac"
cmd="$FLAC --silent --endian=big --sign=signed --decode --force-raw-format --output-name=$name.cmp $name.flac"
echo "### DECODE $name #######################################################" >> ./streams.log
echo "### cmd=$cmd" >> ./streams.log
if $cmd 2>>./streams.log ; then : ; else
......@@ -179,7 +182,7 @@ test_file_piped ()
echo -n "$name: encode via pipes..."
if [ $is_win = yes ] ; then
cmd="flac --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options --stdout $name.raw"
cmd="$FLAC --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options --stdout $name.raw"
echo "### ENCODE $name #######################################################" >> ./streams.log
echo "### cmd=$cmd" >> ./streams.log
if $cmd 1>$name.flac 2>>./streams.log ; then : ; else
......@@ -187,7 +190,7 @@ test_file_piped ()
exit 1
fi
else
cmd="flac --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options --stdout -"
cmd="$FLAC --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options --stdout -"
echo "### ENCODE $name #######################################################" >> ./streams.log
echo "### cmd=$cmd" >> ./streams.log
if cat $name.raw | $cmd 1>$name.flac 2>>./streams.log ; then : ; else
......@@ -197,7 +200,7 @@ test_file_piped ()
fi
echo -n "decode via pipes..."
if [ $is_win = yes ] ; then
cmd="flac --silent --endian=big --sign=signed --decode --force-raw-format --stdout $name.flac"
cmd="$FLAC --silent --endian=big --sign=signed --decode --force-raw-format --stdout $name.flac"
echo "### DECODE $name #######################################################" >> ./streams.log
echo "### cmd=$cmd" >> ./streams.log
if $cmd 1>$name.cmp 2>>./streams.log ; then : ; else
......@@ -205,7 +208,7 @@ test_file_piped ()
exit 1
fi
else
cmd="flac --silent --endian=big --sign=signed --decode --force-raw-format --stdout -"
cmd="$FLAC --silent --endian=big --sign=signed --decode --force-raw-format --stdout -"
echo "### DECODE $name #######################################################" >> ./streams.log
echo "### cmd=$cmd" >> ./streams.log
if cat $name.flac | $cmd 1>$name.cmp 2>>./streams.log ; then : ; else
......@@ -281,6 +284,17 @@ for bps in 8 16 24 ; do
done
done
echo "Testing blocksize variations..."
for disable in '' '--disable-verbatim-subframes --disable-constant-subframes' '--disable-verbatim-subframes --disable-constant-subframes --disable-fixed-subframes' ; do
for blocksize in 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 ; do
for lpc_order in 0 1 2 3 4 5 7 8 9 15 16 17 31 32 ; do
if [ $lpc_order = 0 ] || [ $lpc_order -le $blocksize ] ; then
test_file noise8m32 1 8 "-8 -p -e -l $lpc_order --lax --blocksize=$blocksize $disable"
fi
done
done
done
echo "Testing some frame header variations..."
test_file sine16-01 1 16 "-0 -l $max_lpc_order -m -e -p --lax -b $max_lpc_order"
test_file sine16-01 1 16 "-0 -l $max_lpc_order -m -e -p --lax -b 65535"
......@@ -293,39 +307,45 @@ test_file sine16-01 1 16 "-0 -l $max_lpc_order -m -e -p --lax --sample-rate=9000
echo "Testing option variations..."
for f in 00 01 02 03 04 ; do
for opt in 0 1 2 4 5 6 8 ; do
for extras in '' '-p' '-e' ; do
test_file sine16-$f 1 16 "-$opt $extras"
for disable in '' '--disable-verbatim-subframes --disable-constant-subframes' '--disable-verbatim-subframes --disable-constant-subframes --disable-fixed-subframes' ; do
for opt in 0 1 2 4 5 6 8 ; do
for extras in '' '-p' '-e' ; do
test_file sine16-$f 1 16 "-$opt $extras $disable"
done
done
if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
test_file sine16-$f 1 16 "-b 16384 -m -r 8 -l $max_lpc_order -e -p $disable"
fi
done
if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
test_file sine16-$f 1 16 "-b 16384 -m -r 8 -l $max_lpc_order -e -p"
fi
done
for f in 10 11 12 13 14 15 16 17 18 19 ; do
for opt in 0 1 2 4 5 6 8 ; do
for extras in '' '-p' '-e' ; do
test_file sine16-$f 2 16 "-$opt $extras"
for disable in '' '--disable-verbatim-subframes --disable-constant-subframes' '--disable-verbatim-subframes --disable-constant-subframes --disable-fixed-subframes' ; do
for opt in 0 1 2 4 5 6 8 ; do
for extras in '' '-p' '-e' ; do
test_file sine16-$f 2 16 "-$opt $extras $disable"
done
done
if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
test_file sine16-$f 2 16 "-b 16384 -m -r 8 -l $max_lpc_order -e -p $disable"
fi
done
if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
test_file sine16-$f 2 16 "-b 16384 -m -r 8 -l $max_lpc_order -e -p"
fi
done
echo "Testing noise..."
for channels in 1 2 4 8 ; do
for bps in 8 16 24 ; do
for opt in 0 1 2 3 4 5 6 7 8 ; do
for extras in '' '-p' '-e' ; do
for blocksize in '' '--lax -b 32' '--lax -b 32768' '--lax -b 65535' ; do
test_file noise $channels $bps "-$opt $extras $blocksize"
for disable in '' '--disable-verbatim-subframes --disable-constant-subframes' '--disable-verbatim-subframes --disable-constant-subframes --disable-fixed-subframes' ; do
for channels in 1 2 4 8 ; do
for bps in 8 16 24 ; do
for opt in 0 1 2 3 4 5 6 7 8 ; do
for extras in '' '-p' '-e' ; do
for blocksize in '' '--lax -b 32' '--lax -b 32768' '--lax -b 65535' ; do
test_file noise $channels $bps "-$opt $extras $blocksize $disable"
done
done
done
if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
test_file noise $channels $bps "-b 16384 -m -r 8 -l $max_lpc_order -e -p $disable"
fi
done
if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
test_file noise $channels $bps "-b 16384 -m -r 8 -l $max_lpc_order -e -p"
fi
done
done
Supports Markdown
0% or .
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment